import java.util.Iterator;
import java.util.ArrayList;

/**
  *
  * Moeblierung - Klasse fr das Moebelprojekt.
  *
  * @author claus albowski
  * @version aug 06
  */
public class Moeblierung
{
    private ArrayList moebelListe;
    private int ausgewaehlt;

    /**
     * Konstruktor fr Objekte der Klasse Moeblierung
     */
    public Moeblierung()
    {
        moebelListe = new ArrayList();
        ausgewaehlt=-1;
    }

    /**
     * nimmt ein neues Moebel.
     */
    public boolean neuesMoebel(String moebelArt, 
                            String initX,
                            String initY,
                            String initFarbe,
                            String initRichtung,
                            String initBreite,
                            String initHoehe ){
        Moebel moebel=null;
        int x=verwandleInInt(initX);
        int y=verwandleInInt(initY);
        if (moebelArt=="Stuhl") moebel=new Stuhl(x, y);
        else if (moebelArt=="Tisch") moebel=new Tisch(x, y);
        else if (moebelArt=="Schrank") moebel=new Schrank(x, y);
        else if (moebelArt=="Bett") moebel=new Bett(x, y);
        if (moebel!=null) {
            moebelListe.add(moebel);
            return true;
        }
        else return false;
    }
    
    /**
     * entfernt ein Moebel aus der Darstellung.
     * gibt null zurck, wenn es nicht enthalten war.
     */
    public boolean entferneMoebel(Moebel k){
        return moebelListe.remove(k);
    }
    
    /**
     * gibt die zu zeichnenden Moebel als Liste zurck.
     */
    public ArrayList<FarbigesShape> gibZeichnung(){
        ArrayList<FarbigesShape> grafikelemente=new ArrayList<FarbigesShape>();
        for (Iterator it=moebelListe.iterator();it.hasNext();){
            Moebel moebel=(Moebel)it.next();
            if (moebelListe.indexOf(moebel)!=ausgewaehlt)
            grafikelemente.add(new FarbigesShape(
                                   moebel.gibAktuelleFigur(),
                                   moebel.gibFarbe(),
                                   false));
            else grafikelemente.add(new FarbigesShape(
                                   moebel.gibAktuelleFigur(),
                                   "lightGray",
                                   false));
        }
        return grafikelemente;
    }
    
    /**
     * verwandleInInt
     * Hilfsmethode
     * wandelt den String -wenn mglich- in eine positive int - Zahl um.
     */
    private int verwandleInInt(String s)
      throws NumberFormatException {
        return Integer.parseInt(s, 10);
    }
    // Methoden, um das Auswaehlen zu steuern
    public void waehleAus(){ ausgewaehlt++; if (ausgewaehlt>=moebelListe.size()) ausgewaehlt=0; }
    public void loescheAuswahl() { ausgewaehlt=-1; }
}
